#include "Dialog.h"

Dialog::Dialog(QWidget *parent, const char *name):QListBox(parent,name)
{
  canTouch=TRUE;
  connect(this,SIGNAL(highlighted(int)),SLOT(touch(int)));
  connect(this,SIGNAL(selected(int)),parent,SLOT(prefs()));
}

void Dialog::addProject(MyClass *widget)
{
  QString tmp,item;
  int i;

  navi[count()]=widget;

  QString parse(widget->name());
  i=parse.find(" ");
  tmp=parse.right(parse.length()-i);
  item=tmp.copy();

  item+=" "+widget->getCpt();
  insertItem(item.data());  
  setCurrentItem(count()-1);
}

bool Dialog::isOpen(QString val)
{
  int i;

  for(i=0;i<count();i++)
    if(navi[i]->getFileName()==val)
      return FALSE;
  return TRUE;
}

void Dialog::changeProject(MyClass *widget)
{
  QString tmp,item;
  int i,j,num=-1;
  
  for(i=0;i<NUMPROJECTS;i++)
      if(navi[i]==widget)
	num=i;
  QString parse(widget->name());
  i=parse.find(" ");
  tmp=parse.right(parse.length()-i);
  item=tmp.copy();

  parse=QString(widget->getFileName());

  item+=" "+widget->getCpt();
  if(num>=0)
    {
      changeItem(item.data(),num);
      setCurrentItem(num);
    }
}

void Dialog::rmProject(MyClass *widget)
{
  QString tmp,item;
  int i,j,num=-1;

  canTouch=FALSE;
  for(i=0;i<NUMPROJECTS;i++)
    if(navi[i]==widget)
      num=i;
  if(num>=0)
     {
      removeItem(num);
      for(j=num;j<count();j++)
	navi[j]=navi[(j+1)];
      navi[count()]=NULL;
    }

  if(count()>0)
    {
      canTouch=TRUE;
      touch(0);
    }
}

void Dialog::setHighlighted(MyClass *widget)
{
  int i,num=-5;
  for(i=0;i<NUMPROJECTS;i++)
    if(navi[i]==widget)
      num=i;
  if(num>0)
    setCurrentItem(num); 
}

void Dialog::touch(int val)
{
  if(canTouch)
    {
      navi[val]->raiseIT();
      navi[val]->setWidgetTouched(navi[val]);
    }
}

void Dialog::end()
{
  int i;

  for(i=0;i<count();i++)
    delete(navi[i]);
}










